#main
execute as @e[scores={boss=1,time=120},tag=controller] at @s run function always:boss1

execute as @e[scores={boss=2,bossMinions=0,scene=17..},tag=controller] at @s run function always:boss2

execute at @e[scores={boss=3,bossMinions=0,scene=17..},tag=controller] as @p[scores={hitWizard=1..,playing=1..}] at @s run function always:boss3

execute as @e[scores={boss=4,bossMinions=0,scene=17..},tag=controller] at @s run function always:boss4

execute at @e[scores={boss=5,bossMinions=0,scene=17..},tag=controller] as @p[scores={hitWizard=1..,playing=1..}] at @s run function always:boss5

execute as @e[scores={boss=6,bossMinions=0,scene=17..},tag=controller] at @s run function always:boss6

execute at @e[scores={boss=7,bossMinions=0,scene=17..},tag=controller] as @p[scores={hitWizard=1..,playing=1..}] at @s run function always:boss7

#boss fireballs
execute at @e[scores={wizTime=30},tag=wizard] as @e[scores={boss=1..},tag=wizard] at @s run particle portal ~ ~1 ~ 0.4 0.4 0.4 0 30 force @a
execute at @e[scores={wizTime=30},tag=wizard] as @e[scores={boss=1..},tag=wizard] at @s run teleport @e[tag=wizard] @e[sort=random,tag=bossTeleport,distance=2..,limit=1]
execute as @e[scores={wizTime=30},tag=wizard] as @e[scores={boss=1..},tag=wizard] run scoreboard players set @e[tag=controller] run 1
execute at @e[scores={wizTime=30},tag=wizard] at @e[scores={boss=1..},tag=wizard] as @a at @s run playsound entity.enderman.teleport master @p ~ ~ ~ 1000
execute as @e[scores={wizTime=30},tag=wizard] as @e[scores={boss=1..},tag=wizard] run scoreboard players reset @e[tag=wizard] wizTime

execute at @e[scores={run=1..},tag=controller] at @e[tag=wizard] run summon fireball ~1 ~ ~ {Motion:[3.0,0.0,0.0],direction:[3.0,0.0,0.0]}
execute at @e[scores={run=1..},tag=controller] at @e[tag=wizard] run summon fireball ~ ~ ~-1 {Motion:[0.0,0.0,-3.0],direction:[0.0,0.0,-3.0]}
execute at @e[scores={run=1..},tag=controller] at @e[tag=wizard] run summon fireball ~-1 ~ ~ {Motion:[-3.0,0.0,0.0],direction:[-3.0,0.0,0.0]}
execute at @e[scores={run=1..},tag=controller] at @e[tag=wizard] run summon fireball ~1 ~ ~ {Motion:[0.0,0.0,3.0],direction:[0.0,0.0,3.0]}
execute at @e[scores={run=1..},tag=controller] at @e[tag=wizard] run summon fireball ~2 ~1 ~-2 {Motion:[3.0,0.0,-3.0],direction:[3.0,0.0,-3.0]}
execute at @e[scores={run=1..},tag=controller] at @e[tag=wizard] run summon fireball ~2 ~1 ~2 {Motion:[3.0,0.0,3.0],direction:[3.0,0.0,3.0]}
execute at @e[scores={run=1..},tag=controller] at @e[tag=wizard] run summon fireball ~-2 ~1 ~2 {Motion:[-3.0,0.0,3.0],direction:[-3.0,0.0,3.0]}
execute at @e[scores={run=1..},tag=controller] at @e[tag=wizard] run summon fireball ~-2 ~1 ~-2 {Motion:[-3.0,0.0,-3.0],direction:[-3.0,0.0,-3.0]}
execute as @e[scores={run=1..},tag=controller] run scoreboard players set @e[tag=controller] run 0

#muncher explosions
execute as @e[type=zombie,scores={wizTime=20},tag=bossMinion] run scoreboard players set @e[sort=random,tag=explode] run 1
execute at @e[type=zombie,scores={wizTime=20},tag=bossMinion] at @e[scores={run=1..},tag=explode] run particle explosion ~ ~ ~ 1.5 0.5 1.5 0 20
execute at @e[type=zombie,scores={wizTime=20},tag=bossMinion] as @a at @s run playsound entity.generic.explode master @p ~ ~ ~ 1000
execute at @e[type=zombie,scores={wizTime=20},tag=bossMinion] as @e[scores={run=1..},tag=explode] at @s run effect give @a[distance=..4] instant_damage
execute as @e[type=zombie,scores={wizTime=20},tag=bossMinion] run scoreboard players set @s wizTime 21

execute as @e[type=zombie,scores={wizTime=40},tag=bossMinion] at @s run scoreboard players set @e[sort=random,tag=explode,limit=2] run 1
execute at @e[type=zombie,scores={wizTime=40},tag=bossMinion] at @e[scores={run=1..},tag=explode] run particle explosion ~ ~ ~ 1.5 0.5 1.5 0 20
execute at @e[type=zombie,scores={wizTime=40},tag=bossMinion] as @a at @s run playsound entity.generic.explode master @p ~ ~ ~ 1000
execute at @e[type=zombie,scores={wizTime=40},tag=bossMinion] as @e[scores={run=1..},tag=explode] at @s run effect give @a[distance=..4] instant_damage
execute as @e[type=zombie,scores={wizTime=40},tag=bossMinion] run scoreboard players set @s wizTime 41

execute as @e[type=zombie,scores={wizTime=60},tag=bossMinion] at @s run scoreboard players set @e[sort=random,tag=explode,limit=3] run 1
execute at @e[type=zombie,scores={wizTime=60},tag=bossMinion] at @e[scores={run=1..},tag=explode] run particle explosion ~ ~ ~ 1.5 0.5 1.5 0 20
execute at @e[type=zombie,scores={wizTime=60},tag=bossMinion] as @a at @s run playsound entity.generic.explode master @p ~ ~ ~ 1000
execute at @e[type=zombie,scores={wizTime=60},tag=bossMinion] as @e[scores={run=1..},tag=explode] at @s run effect give @a[distance=..4] instant_damage
execute as @e[type=zombie,scores={wizTime=60},tag=bossMinion] run scoreboard players reset @e[type=zombie,tag=bossMinion] wizTime

scoreboard players reset @e[tag=explode] run

#boss stuff
execute as @e[scores={boss=1..3},tag=controller] run bossbar set bar:boss value 80
execute as @e[scores={boss=4..5},tag=controller] run bossbar set bar:boss value 70
execute as @e[scores={boss=6..7},tag=controller] run bossbar set bar:boss value 60
execute as @e[scores={boss=8},tag=controller] run bossbar set bar:boss value 50
execute as @e[scores={boss=9,time=0..500},tag=controller] run bossbar set bar:boss value 50
execute as @e[scores={boss=9,time=501..800},tag=controller] run bossbar set bar:boss value 40
execute as @e[scores={boss=9,time=801..1100},tag=controller] run bossbar set bar:boss value 30
execute as @e[scores={boss=9,time=1101..1400},tag=controller] run bossbar set bar:boss value 20
execute as @e[scores={boss=9,time=1401..1600},tag=controller] run bossbar set bar:boss value 10

bossbar set bar:boss players @a
scoreboard players set @e[tag=controller] bossMinions 0
execute as @e[tag=bossMinion] run scoreboard players add @e[tag=controller] bossMinions 1
execute as @e[scores={boss=1..},tag=wizard] run data merge entity @s {Invulnerable:0}
execute as @p[scores={playing=1..}] at @s run teleport @e[tag=bossBattle] ~ -5 ~
execute as @e[scores={bossMinions=0,scene=17..},tag=controller] run kill @e[tag=miniMiniBossMinion]
execute as @e[tag=wizard] run data merge entity @s {Health:999}
execute as @e[type=zombie,tag=bossMinion] at @s run playsound effects.laugh master @p ~ ~ ~ 0.8 0.5
execute as @e[scores={boss=9..,scene=17..,time=1599..},tag=controller] run bossbar remove bar:boss
